All Classes Namespaces Functions Pages
hal Namespace Reference

## Classes

class | Alignment
class | BottomSegment
class | BottomSegmentIterator
class | CLParser
class | ColumnIterator
class | DNAIterator
class | GappedBottomSegmentIterator
class | GappedSegmentIterator
class | GappedTopSegmentIterator
class | Genome
class | MappedSegment
class | MetaData
class | PositionCache
class | Rearrangement
class | Segment
class | SegmentedSequence
class | SegmentIterator
class | Sequence
class | SequenceIterator
class | SlicedSegment
class | TopSegment
class | TopSegmentIterator

## Functions

AlignmentPtr | hdf5AlignmentInstance ()
AlignmentConstPtr | hdf5AlignmentInstanceReadOnly ()
AlignmentPtr | hdf5AlignmentInstance (const H5::FileCreatPropList &fileCreateProps, const H5::FileAccPropList &fileAccessProps, const H5::DSetCreatPropList &datasetCreateProps, bool inMemory=false)
AlignmentConstPtr | hdf5AlignmentInstanceReadOnly (const H5::FileCreatPropList &fileCreateProps, const H5::FileAccPropList &fileAccessProps, const H5::DSetCreatPropList &datasetCreateProps, bool inMemory=false)
AlignmentPtr | openHalAlignment (const std::string &path, CLParserConstPtr options)
AlignmentConstPtr | openHalAlignmentReadOnly (const std::string &path, CLParserConstPtr options)
bool | operator== (BottomSegmentIteratorConstPtr p1, BottomSegmentIteratorConstPtr p2)
bool | operator!= (BottomSegmentIteratorConstPtr p1, BottomSegmentIteratorConstPtr p2)
template<>
std::string | CLParser::convertFromString< std::string > (const std::string &token) const
CLParserPtr | hdf5CLParserInstance (bool createOptions=false)
std::ostream & | operator<< (std::ostream &os, const ColumnIterator &cit)
bool | compatibleWithVersion (const std::string &version)
std::vector< std::string > | chopString (const std::string &inString, const std::string &separator)
char | reverseComplement (char c)
void | reverseComplement (std::string &s)
bool | isNucleotide (char c)
bool | isTransition (char c1, char c2)
bool | isSubstitution (char c1, char c2)
bool | isTransversion (char c1, char c2)
bool | isMissingData (char c)
bool | isMasked (char c)
bool | isFourfoldDegenerate (char c1, char c2)
hal_size_t | hammingDistance (const std::string &s1, const std::string &s2)
const Genome * | getLowestCommonAncestor (const std::set< const Genome * > &inputSet)
void | getGenomesInSpanningTree (const std::set< const Genome * > &inputSet, std::set< const Genome * > &outputSet)
void | getGenomesInSubTree (const Genome *root, std::set< const Genome * > &outputSet)
std::ostream & | operator<< (std::ostream &os, const DNAIterator *dna)
bool | operator== (GappedBottomSegmentIteratorConstPtr p1, GappedBottomSegmentIteratorConstPtr p2)
bool | operator!= (GappedBottomSegmentIteratorConstPtr p1, GappedBottomSegmentIteratorConstPtr p2)
bool | operator== (GappedTopSegmentIteratorConstPtr p1, GappedTopSegmentIteratorConstPtr p2)
bool | operator!= (GappedTopSegmentIteratorConstPtr p1, GappedTopSegmentIteratorConstPtr p2)
std::ostream & | operator<< (std::ostream &os, const Segment &s)
bool | operator< (SegmentIteratorConstPtr segmentIt, hal_index_t genomePos)
bool | operator> (SegmentIteratorConstPtr segmentIt, hal_index_t genomePos)
bool | operator== (SequenceIteratorConstPtr p1, SequenceIteratorConstPtr p2)
bool | operator!= (SequenceIteratorConstPtr p1, SequenceIteratorConstPtr p2)
bool | operator< (SlicedSegmentConstPtr segmentIt, hal_index_t genomePos)
bool | operator> (SlicedSegmentConstPtr segmentIt, hal_index_t genomePos)
bool | operator== (TopSegmentIteratorConstPtr p1, TopSegmentIteratorConstPtr p2)
bool | operator!= (TopSegmentIteratorConstPtr p1, TopSegmentIteratorConstPtr p2)
void | validateBottomSegment (const BottomSegment *bottomSegment)
void | validateTopSegment (const TopSegment *topSegment)
void | validateSequence (const Sequence *sequence)
void | validateGenome (const Genome *genome)
void | validateDuplications (const Genome *genome)
void | validateAlignment (AlignmentConstPtr alignment)

## Variables

const hal_index_t | NULL_INDEX

## Detailed Description

HAL API namespace

## Function Documentation

std::vector<std::string> hal::chopString | ( | const std::string & | inString,
|  | const std::string & | separator
| ) |  |

C++ style strtok-type function. Can't remember why I wrote it

hal_size_t hal::hammingDistance | ( | const std::string & | s1,
|  | const std::string & | s2
| ) |  |

inline

Count the mutations between two DNA strings

AlignmentPtr hal::hdf5AlignmentInstance | ( |  | ) |

Get an instance of an HDF5-implemented Alignment with default parameters for everything

AlignmentPtr hal::hdf5AlignmentInstance | ( | const H5::FileCreatPropList & | fileCreateProps,
|  | const H5::FileAccPropList & | fileAccessProps,
|  | const H5::DSetCreatPropList & | datasetCreateProps,
|  | bool | inMemory = `false`
| ) |  |

Get an instance of an HDF5-implemented Alignment while specifying

Parameters

  fileCreateProps | File creation properties. fairly low-level and should generally be set to H5::FileCreatPropList::DEFAULT
  fileAccessProps | File access properties. Contains cache-related stuff
  datasetCreateProps | Compression and chunking parameters among others
  inMemory | Store all data in memory (overrides and disables hdf5 cache)

AlignmentConstPtr hal::hdf5AlignmentInstanceReadOnly | ( |  | ) |

Get read-only instance of an HDF5-implemented Alignment with default parameters for everything

AlignmentConstPtr hal::hdf5AlignmentInstanceReadOnly | ( | const H5::FileCreatPropList & | fileCreateProps,
|  | const H5::FileAccPropList & | fileAccessProps,
|  | const H5::DSetCreatPropList & | datasetCreateProps,
|  | bool | inMemory = `false`
| ) |  |

Get a read-only instance of an HDF5-implemented Alignment while specifying

Parameters

  fileCreateProps | File creation properties. fairly low-level and should generally be set to H5::FileCreatPropList::DEFAULT
  fileAccessProps | File access properties. Contains cache-related stuff
  datasetCreateProps | Compression and chunking parameters among others
  inMemory | Store all data in memory (overrides and disables hdf5 cache)

CLParserPtr hal::hdf5CLParserInstance | ( | bool | createOptions = `false` | ) |

Get an instance of an HDF5-implemented CLParser

Parameters

  createOptions | set to true if tool will need to create a new hal file (as opposed to just reading an existing one)

bool hal::isFourfoldDegenerate | ( | char | c1,
|  | char | c2
| ) |  |

inline

test if 3rd codon position is 4-fold degenerate given first 2 positions

bool hal::isNucleotide | ( | char | c | ) |

inline

Check if a DNA character is a valid base (or n-chracter)

AlignmentPtr hal::openHalAlignment | ( | const std::string & | path,
|  | CLParserConstPtr | options
| ) |  |

Get an alignment instance from a file by automatically detecting which implementation to use. (will currently (and probably forever more) just return an HDF5 instance since that's all that exists)

Parameters

  path | Path of file to open
  options | Command line options information

AlignmentConstPtr hal::openHalAlignmentReadOnly | ( | const std::string & | path,
|  | CLParserConstPtr | options
| ) |  |

Get a read-only alignment instance from a file by automatically detecting which implementation to use. (will currently (and probably forever more) just return an HDF5 instance since that's all that exists)

Parameters

  path | Path of file to open
  options | Command line options information

char hal::reverseComplement | ( | char | c | ) |

inline

Get the DNA reverse complement of a character. If the input is not a nucleotide, then just return it as is (ie no error checking)

void hal::reverseComplement | ( | std::string & | s | ) |

Get the reversed complement of a string (in place

void hal::validateAlignment | ( | AlignmentConstPtr | alignment | ) |

Go through an alignment, and throw an excpetion if anything appears out of whack.

void hal::validateBottomSegment | ( | const BottomSegment * | bottomSegment | ) |

Go through a bottom segment, and throw an exception if anything appears out of whack.

void hal::validateDuplications | ( | const Genome * | genome | ) |

Go through a genome, and throw an exception if any duplications appears out of whack.

void hal::validateGenome | ( | const Genome * | genome | ) |

Go through a genome, and throw an exception if anything appears out of whack.

void hal::validateSequence | ( | const Sequence * | sequence | ) |

Go through a sequence, and throw an exception if anything appears out of whack.

void hal::validateTopSegment | ( | const TopSegment * | topSegment | ) |

Go through a top segment, and throw an exception if anything appears out of whack.